/* ------------------------------ */
/* Flex refer to this link */
/* https://css-tricks.com/snippets/css/a-guide-to-flexbox/ */
/* ------------------------------ */

@mixin flex-parent($direction, $wrap, $justify, $items, $content) {
    display: flex;
    @if $direction != '' {
        flex-direction: $direction; /* row | row-reverse | column | column-reverse */
    }
    @if $wrap != '' {
        flex-wrap: $wrap; /* nowrap | wrap | wrap-reverse */
    }
    @if $justify != '' {
        justify-content: $justify; /* flex-start | flex-end | center | space-between | space-around | space-evenly | start | end | left | right ... + safe | unsafe */
    }
    @if $items != '' {
        align-items: $items; /* stretch | flex-start | flex-end | center | baseline | first baseline | last baseline | start | end | self-start | self-end + ... safe | unsafe */
    }
    @if $content != '' {
        align-content: $content; /* flex-start | flex-end | center | space-between | space-around | space-evenly | stretch | start | end | baseline | first baseline | last baseline + ... safe | unsafe */
    }
}

@mixin flex-child($order, $grow, $shrink, $basis, $flex, $align) {
    @if $order != '' {
        order: $order;
    }
    @if $grow != '' {
        flex-grow: $grow;
    }
    @if $shrink != '' {
        flex-shrink: $shrink;
    }
    @if $basis != '' {
        flex-basis: $basis;
    }
    @if $flex != '' {
        flex: $flex;
    }
    @if $align != '' {
        align-self: $align; /* auto | flex-start | flex-end | center | baseline | stretch */
    }
}


@mixin position-center {
    position: absolute;
    top: 50%;
    left: 50%;
    transform: translate(-50%, -50%);
}

@mixin position-top {
    position: absolute;
    top: 0;
    left: 50%;
    transform: translate(-50%, 0);
}

@mixin position-top-right {
    position: absolute;
    top: 0;
    right: 0;
    transform: translate(0, 0);
}

@mixin position-right {
    position: absolute;
    top: 50%;
    right: 0;
    transform: translate(0, -50%);
}

@mixin position-bottom-right {
    position: absolute;
    bottom: 0;
    right: 0;
    transform: translate(0, 0);
}

@mixin position-bottom {
    position: absolute;
    bottom: 0;
    left: 50%;
    transform: translate(-50%, 0);
}

@mixin position-bottom-left {
    position: absolute;
    bottom: 0;
    left: 0;
    transform: translate(0, 0);
}

@mixin position-left {
    position: absolute;
    top: 50%;
    left: 0;
    transform: translate(0, -50%);
}

@mixin position-top-left {
    position: absolute;
    top: 0;
    left: 0;
    transform: translate(0, 0);
}

@mixin position-horizontal-center-flex {
    @include flex-parent(row, '', center, '', '');
}

@mixin position-vertical-center-flex {
    @include flex-parent(column, '', center, '', '');
}

@mixin position-vertical-center-table-parent {
    display: table;
}

@mixin position-vertical-center-table-child {
    display: table-cell;
    vertical-align: middle;
}
